<?php
@include("geoip.inc");

class login_activity extends rcube_plugin{
public $ip;
public $hostname;
public $flags_dir="/images/login_activity/flags";
public $local_image_path ="/images/login_activity";
public $isLocal;
public $location;

//array of rules for local connections
public $RU_Local= array( array( "Pattern" => "/^192./",
                         "Type" => "ip",
                         "Description" => "Rutgers",
                         "Link" => "http://www.rutgers.edu",
                         "Image" => "favicon.gif",
                         "Comment" => "Rutgers University"),
                   array( "Pattern" => "/^192.168./",
                          "Type" => "ip",
                          "Description" => "JLA",
                          "Link" => "http://jla.rutgers.edu",
                          "Image" => "jla.gif",
                          "Comment" => "JLA, CSS/OSS Server"),
                   array( "Pattern" => "/^172.16xi-.31./",
                          "Type" => "ip",
                          "Description" => "Rutgers",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "Rutgers University"),
                   array( "Pattern" => "/^172.30/",
                          "Type" => "ip",
                          "Description" => "ResNet",
                          "Link" => "http://resnet.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "Rutgers University ResNet"),
                   array( "Pattern" => "/^172.16./",
                          "Type" => "ip",
                          "Description" => "Rutgers",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "Rutgers University"),
                   array( "Pattern" => "/^128.6./",
                          "Type" => "ip",
                          "Description" => "Rutgers",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "Rutgers University"),
                   array( "Pattern" => "/^10./",
                          "Type" => "ip",
                          "Description" => "Rutgers",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "RUWireless"),
                   array( "Pattern" => "/^165.230./",
                          "Type" => "ip",
                          "Description" => "Rutgers",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
                          "Comment" => "Rutgers University"),
                   array( "Pattern" => "/login.ruw.rutgers.edu/",
                          "Type" => "hostname",
                          "Description" => "RUWireless",
                          "Link" => "http://www.rutgers.edu",
                          "Image" => "favicon.gif",
			  "Comment" => "RUWireless"),
                   array( "Pattern" => "/oss-staff.rutgers.edu/",
                          "Type" => "hostname",
                          "Description" => "OSS",
                          "Link" => "http://sauron.rutgers.edu",
                          "Image" => "sauron.gif",
                          "Comment" => "OSS Hill 128"),
                  array( "Pattern" => "/127.0.0.1/",
                          "Type" => "ip",
                          "Description" => "Localhost",
                          "Link" => "http://sauron.rutgers.edu",
                          "Image" => "sauron.gif",
			  "Comment" => "Localhost"),
                  array(  "Pattern" => "/^192.168.227./",
                          "Type" => "ip",
                          "Description" => "OSS",
                          "Link" => "http://sauron.rutgers.edu",
                          "Image" => "sauron.gif",
                          "Comment" => "OSS Hill 128"));


function init(){
 $this->add_hook('template_object_loginactivity', array($this, 'print_login_info'));
 $this->add_hook('login_after', array($this, 'rotate_old_times'));
 $this->register_action('plugin.login_activity', array($this, 'show_details'));
 $this->include_stylesheet("login_activity.css");
}

function get_flag_path($ip){
	if (strcmp($ip,"") == 0){return "$this->flags_dir/blank.gif";}
	$gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
	$code = strtolower(geoip_country_code_by_addr($gi,$ip));	
	geoip_close($gi);
	$path = "$this->flags_dir/$code.gif";
	return $path;
	

}

function show_details(){
	$rcmail = rcmail::get_instance();
	$rcmail->output->set_pagetitle("Login History Details");
	$rcmail->output->add_handlers(array('loginactivitycontent' => array($this,'content')));	
	$rcmail->output->send('loginactivity');
}

function check_suspicious_activity(){
	$isBad=true; #assume it is bad, we change this to false if it matches one of the previous logins
	
	$rcmail = rcmail::get_instance();
        $user_id = ($rcmail->user->data['user_id']);
	$query = "SELECT last_ip5 FROM users WHERE user_id = '$user_id'";
	$res = mysql_query($query); 
	$row = mysql_fetch_assoc($res);

	# if they haven't logged in at least 5 times, don't bother warning them about inconsistant behavior
	#if (strcmp($row['last_ip5'],"N/A")==0){
	#	return "";
	#}
 	


	$query = "SELECT last_ip1 FROM users WHERE user_id = '$user_id'";
	$res = mysql_query($query); 
	$row = mysql_fetch_assoc($res);
 	$lookup= self::get_login_info($row['last_ip1']);
        $last_location = $lookup['Location'];
        if ($lookup['isLocal']){
		$temp = $lookup['Location'];	
		$oldPlace = $temp['Comment'];
	}else{
		$oldPlace = $lookup['Location'];
	}

	for($index=2; $index <= 5; $index++){
		$query = "SELECT last_ip$index FROM users WHERE user_id = '$user_id'";
		$res = mysql_query($query);
		$row = mysql_fetch_assoc($res);
		$lookup= self::get_login_info($row["last_ip$index"]);
		
		if ($lookup['isLocal']){
			$temp = $lookup['Location'];	
			$toCompare = $temp['Comment'];
		}else{
			$toCompare = $lookup['Location'];
		}
		if (strcmp($toCompare,$oldPlace)==0){ $isBad = false;}
	}

	if ($isBad){
		$warnMessage= "<b>WARNING!</b> Your last login was from $oldPlace, which seems inconsistant from your regular usage. Your account may be compromised. <a href='http://roundcube-test/?_task=dummy&_action=plugin.login_activity'>Click Here</a> for more info.";
		$out .= "<script type=\"text/javascript\">$(document).ready(function() {
	
	$.jnotifica(\"$warnMessage\", {
        position : 'top',
        classes : 'login_bad',
        background : 'red',
        timeout: 9999999999
    });
);</script>";
	
	}
	return $out;
}


function get_login_info($ip){
	$RU_Local=$this->RU_Local;
	if (strcmp($ip,"N/A")==0){
		return array("Location"=>"","isLocal"=>false);
	}
         //get country name, if connection is from Rutgers internal network returns ""
         #$location = apache_note("GEOIP_COUNTRY_NAME");
         #$double_check = apache_note("GEOIP_COUNTRY_NAME");
        $gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
	$location = geoip_country_name_by_addr($gi,$ip);
	$double_check = geoip_country_name_by_addr($gi,$ip);
	
	/* there is a bug in the api, occasionally we get bogus results
         * so we check twice. If we get different results, one of them must be bad, so check a third time
	 * The bug is very intermittent, so if it happened once already, we can assume it won't happen again on the third try
	 * (as per richton)
	 */
	if ($location != $double_check){
	        $location_new = geoip_country_name_by_addr($gi,$ip);
		log_lookup_bug($location,$double_check,$location_new,$ip);
	}
geoip_close($gi);

         $isLocal=false;
         //Check if connection is from Rutgers local stuff
         //if it is, replace country name with something sane
         foreach($RU_Local as $row => $rule){
                 if( $rule["Type"] == "ip"){
                         if (preg_match($rule['Pattern'] ,$ip)){
                                 $location=$rule;
                                 $isLocal=true;
                         }
                 }else{
                         if (preg_match($rule['Pattern'],$this->hostname)){
                                 $location=$rule;
                                 $isLocal=true;
                         }

                 }
         }
	return array("Location"=>$location,"isLocal"=>$isLocal);
}



function content($attrib)
    {
      	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);

	$out .= "<b><font size=+1>Your Activity</b></font><br>\n";
	$out .= "<p>This feature provides information about your webmail login activity, alerting you to suspicious access. ";
	$out .= "<br><br>If any of the times or places seem incorrect, your account may have been accessed by an unauthorized person, and you should contact the Help Desk immediately. ";
	$out .= "<a href='http://css.rutgers.edu/webmail/faq' target='_blank'>Learn more</a></p>\n";
	$out .= "<center>";
	$out .= "<table class='login_history' width='97%' align='center' border='0' cellpadding='8' cellspacing='0'>\n";
	$out .= "<tr>\n";
	$out .= "<td bgcolor='#D30f33'><b>IP</b></td>\n";
	$out .= "<td bgcolor='#d30f33'><b>Location</b></td>\n";
	$out .= "<td bgcolor='#d30f33'><b>Date/Time</b></td>\n";
	
	
	for($index=1; $index <= 5; $index++){
		$out .= "<tr>";
		$query = "SELECT last_ip$index FROM users WHERE user_id = '$user_id'";
		$res=mysql_query($query);
		$row=mysql_fetch_assoc($res);
		$ip=$row["last_ip$index"];	
		if ($ip == NULL){
			continue;	
		}
		$out .= "<td>$ip</td>";

		$lookup= self::get_login_info($ip);
		$location = $lookup['Location'];
		$isLocal = $lookup['isLocal'];
		if ($isLocal){
			$place = $location['Comment'];
			$flag=$this->local_image_path . "/" . $location['Image'];
			$out .= "<td><img src=\"$flag\" /> $place</td>";
		}else{
			$flag = self::get_flag_path($row['last_ip1']);
			$out .= "<td><img src=\"$flag\" /> $location</td>";
		}
		if ($index==1){
			$query = "SELECT last_login FROM users WHERE user_id = '$user_id'";
			$res=mysql_query($query);
			$row=mysql_fetch_assoc($res);
			$date=$row["last_login"];	
			if (strcmp($date,"0000-00-00 00:00:00")==0){
				$out .= "<td>N/A</td>";	
			}else{
				$out .= "<td>$date</td>";
			}
		}else{
			$query = "SELECT last_login$index FROM users WHERE user_id = '$user_id'";
			$res=mysql_query($query);
			$row=mysql_fetch_assoc($res);
			$date=$row["last_login$index"];	
			$out .= "<td>$date</td>";
		}	
	
		//if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
		//otherwise, its just a country name

		$out .= "</tr>\n";

	}
	
	
	$out .= "</table>\n";
	$out .= "</center>\n";
	$out .= "<br>\n<a href='?_task=mail' >Back</a>";
      	return $out;
    }


function log_lookup_bug($location1, $location2,$location_final,$ip){
	$message = "GEOIP lookup error: $ip resolved to $location1 and then $location2. On the third try, it resolved to $location_final";	
	syslog(LOG_ERR,$message);
	mail("root@jla.rutgers.edu,oss@oss.rutgers.edu","GeoIp Lookup Error",$message);
}

function print_login_info($args){
$rcmail = rcmail::get_instance();
$args['content'] .= self::check_suspicious_activity();
if( ! isset($rcmail->user->data['user_id'])){
	return $args;
}
$this->ip = $_SERVER['REMOTE_ADDR'];
$this->hostname = $_SERVER['REMOTE_HOST'];
$lookup=self::get_login_info($this->ip);
$this->isLocal=$lookup['isLocal'];
$this->location = $lookup['Location'];

#if (strcmp($_COOKIE['Checked_geoIP'], "True")!=0){
if (empty($_SESSION['geoip'])){
	#$rcmail->setcookie("Checked_geoIP","True",0);
	$_SESSION['geoip']='True';
	self::save_login_ip($this->ip);
}

$args['content'] .= "\n<div id=login_time>\n";
$args['content'] .= "\n<b>Current Login:</b>\n<br>\n";
 //if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
 //otherwise, its just a country name
if ( $this->isLocal){
                 $args['content'] .=  "<img src=\"" . $this->local_image_path ."/" . $this->location['Image'] . "\"/>";
                 $args['content'] .=  $this->ip . " (" . $this->location['Description'] . ")\n<br>\n";
                 $args['content'] .=  $this->location['Comment'];

         }else{
		$flag = self::get_flag_path($row['last_ip1']);
		$args['content'] .= "<img src=\"$flag\" />";
                $args['content'] .=  $this->ip . "<br>" . $location;
         }
$args['content'] .=  "\n<br>\n";
$args['content'] .= self::get_old_login_ip();
$args['content'] .= "<br>\n<a href='?_task=dummy&_action=plugin.login_activity'>Details</a>";
$args['content'] .= "\n<a href='http://css.rutgers.edu/webmail/faq' target='_blank'> FAQ </a>";
$args['content'] .=  "</div>\n";
return $args;
}

 function save_login_ip($ip){
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	$query = "SELECT current_ip FROM users WHERE user_id = '$user_id'";
 	$res=mysql_query($query);
	$row=mysql_fetch_assoc($res);
	#whatever is in the current_ip field from last time is now our old ip
	$old_login=$row['current_ip'];
	$query = "UPDATE users SET last_ip1='$old_login' WHERE user_id='$user_id'";
	$res = mysql_query($query);
	$query = "UPDATE users SET current_ip='$ip' WHERE user_id='$user_id'";
	$res = mysql_query($query);
 }

function rotate_old_ips(){
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	for($index=5; $index > 1; $index--){
		$one_newer = $index-1;
		$query = "SELECT last_ip$one_newer FROM users WHERE user_id = '$user_id'";
		$res=mysql_query($query);
		$row=mysql_fetch_assoc($res);
		$newer_login=$row["last_ip$one_newer"];
		
		$query = "UPDATE users SET last_ip$index='$newer_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
	}

}

function rotate_old_times(){
	self::rotate_old_ips();
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	for($index=5; $index > 2; $index--){
		$one_newer = $index-1;
		$query = "SELECT last_login$one_newer FROM users WHERE user_id = '$user_id'";
		$res=mysql_query($query);
		$row=mysql_fetch_assoc($res);
		$newer_login=$row["last_login$one_newer"];
		$query = "UPDATE users SET last_login$index='$newer_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
	}
	#the first/current one is called last_login, not last_login1 (for compatability), so its a special case
		$query = "SELECT last_login FROM users WHERE user_id = '$user_id'";
		$res=mysql_query($query);
		$row=mysql_fetch_assoc($res);
		$last_login = $rcmail->user->data['last_login'];
		$empty_time = new DateTime('0000-00-00 00:00:00');
		if (strcmp($last_login,"0000-00-00 00:00:00")==0){
			$last_login="N/A";	
		}
		$query = "UPDATE users SET last_login2='$last_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
}


function get_old_login_ip(){
	$args['content'] .=  "<b>Previous Login:</b>\n<br>\n";
 	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	$query = "SELECT last_ip1 FROM users WHERE user_id = '$user_id'";
	$res = mysql_query($query);
	if (mysql_num_rows($res)){
		$row = mysql_fetch_assoc($res);
		if ($row['last_ip1'] == NULL){
		 $args['content'] .=  "No previous login detected.\n<br>";
		}else{
			$lookup= self::get_login_info($row['last_ip1']);
			$location = $lookup['Location'];
			$isLocal = $lookup['isLocal'];
			//if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
			 //otherwise, its just a country name
			if ( $isLocal){
				  $args['content'] .=  "<img src=\"" . $this->local_image_path ."/" . $location['Image'] . "\"/>";
				  $args['content'] .=  $row['last_ip1'] . " (" . $location['Description'] . ")\n<br>\n";
				  $args['content'] .=  $location['Comment'];
		 
			  }else{
				$flag = self::get_flag_path($row['last_ip1']);
				$args['content'] .= "<img src=\"$flag\" />";
				$args['content'] .=  $row['last_ip1'] . " <br>" . $location;
			  }
			
		}
	}else{
		$args['content'] .=  "$rcmail->user was not found as a valid user.";
	}
	return $args['content'];
}

}
?>
